var querystring = require('querystring');
var Perry = exports;

Perry.stringify = function(obj, sep, eq, bo, bc, prefix) {
  sep = sep || '&';
  eq = eq || '=';
  bo = bo || '[';
  bc = bc || ']';
  obj = (obj === null) ? undefined : obj;
  
  return Object.keys(obj).map(function(i) {
    var key = prefix ? 
      prefix + bo + Perry.escape(i) + bc : 
      Perry.escape(i);
    var value = obj[i];
    
    return typeof value == 'object' ? 
      Perry.stringify(value, sep, eq, bo, bc, key) :
      key + eq + Perry.escape(value);
  }).join(sep);
}

Perry.parse = function(str, sep, eq, bo, bc) {
  sep = sep || '&';
  eq = eq || '=';
  bo = bo || '[';
  bc = bc || ']';
  str = str || '';
  
  function constructObj(array, value) {
    var obj = {};
    if(array.length) {
      obj[array.shift()] = constructObj(array, value);
    } else {
      return value;
    }
    return obj;
  }

  function mergeRecursive(targetObj, sourceObj) {
    // http://viktorbezdek.com/post/3443234398/js-snippet-recursively-merging-two-objects-in-js
    Object.keys(sourceObj).forEach(function(property) {
      targetObj[property] = (sourceObj[property].constructor == Object && targetObj[property]) 
        ? mergeRecursive(targetObj[property], sourceObj[property])
        : sourceObj[property];
    });
    return targetObj;
  }
  
  var eql_regex = new RegExp("(^.*?)[" + eq + "](.*)");
  var arr_regex = new RegExp("\\" + bo + "?(.*?)[\\" + bc + "\\" + bo + "]","g"); // thanks @mkorfmann for this solution
  
  var obj = {};
  str.split(sep).forEach(function(chunk) {
    var parts = chunk.match(eql_regex);
    var key = parts[1];
    var val = Perry.unescape(parts[2], true);
    
    var flat_keys = [];
    while((match = arr_regex.exec(key)) != null) {
      flat_keys.push(Perry.unescape(match[1], true));
    }
    
    if(flat_keys.length) {
      obj = mergeRecursive(obj, constructObj(flat_keys, val));
    } else {
      obj[Perry.unescape(key, true)] = val;
    }
  });
  return obj;
}

Perry.escape = function(str) {
  return encodeURIComponent(str);
}

Perry.unescape = function(s, decodeSpaces) {
  return querystring.unescapeBuffer(s, decodeSpaces).toString();
};